crypton-0.34: Cryptography Primitives sink

License | BSD-style
Maintainer | Olivier Chéron <olivier.cheron@gmail.com>
Stability | experimental
Portability | unknown
Safe Haskell | Safe-Inferred
Language | Haskell2010

Crypto.System.CPU

Description

Gives information about crypton runtime environment.

Synopsis

- data ProcessorOption
  - = AESNI
  - | PCLMUL
  - | RDRAND
- processorOptions :: [ProcessorOption]

# Documentation

data ProcessorOption Source #

CPU options impacting cryptography implementation and library performance.

Constructors

AESNI | Support for AES instructions, with flag `support_aesni`
PCLMUL | Support for CLMUL instructions, with flag `support_pclmuldq`
RDRAND | Support for RDRAND instruction, with flag `support_rdrand`

#### Instances

Instances details

Data ProcessorOption Source # |

Instance details

Defined in Crypto.System.CPU

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> ProcessorOption -> c ProcessorOption Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c ProcessorOption Source #

toConstr :: ProcessorOption -> Constr Source #

dataTypeOf :: ProcessorOption -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c ProcessorOption) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c ProcessorOption) Source #

gmapT :: (forall b. Data b => b -> b) -> ProcessorOption -> ProcessorOption Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> ProcessorOption -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> ProcessorOption -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> ProcessorOption -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> ProcessorOption -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> ProcessorOption -> m ProcessorOption Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> ProcessorOption -> m ProcessorOption Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> ProcessorOption -> m ProcessorOption Source #

Enum ProcessorOption Source # |

Instance details

Defined in Crypto.System.CPU

Methods

succ :: ProcessorOption -> ProcessorOption Source #

pred :: ProcessorOption -> ProcessorOption Source #

toEnum :: Int -> ProcessorOption Source #

fromEnum :: ProcessorOption -> Int Source #

enumFrom :: ProcessorOption -> [ProcessorOption] Source #

enumFromThen :: ProcessorOption -> ProcessorOption -> [ProcessorOption] Source #

enumFromTo :: ProcessorOption -> ProcessorOption -> [ProcessorOption] Source #

enumFromThenTo :: ProcessorOption -> ProcessorOption -> ProcessorOption -> [ProcessorOption] Source #

Show ProcessorOption Source # |
Instance details Defined in Crypto.System.CPU Methods showsPrec :: Int -> ProcessorOption -> ShowS Source # show :: ProcessorOption -> String Source # showList :: [ProcessorOption] -> ShowS Source #
Eq ProcessorOption Source # |
Instance details Defined in Crypto.System.CPU Methods (==) :: ProcessorOption -> ProcessorOption -> Bool Source # (/=) :: ProcessorOption -> ProcessorOption -> Bool Source #

processorOptions :: [ProcessorOption] Source #

Options which have been enabled at compile time and are supported by the current CPU.